/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <stdio.h>
#include <string.h>

int main(int argc, char **argv) {
    FILE * fp;
    char string[512], name[64], *p;
    int addr;

    printf("\n");
    printf("#ifndef GPU_H\n");
    printf("#define GPU_H\n");
    printf("\n");
    printf("// GPU memory map definitions\n// Generated automatically by map2def\n");
    printf("\n");

    if ((fp = fopen("game_gpu.map", "r")) != NULL) {
        fseek(fp, 0L, SEEK_SET);
        while(fgets(string, sizeof(string) - 1, fp) != NULL) {
            if (sscanf(string, " 0x%x %s", &addr, name) == 2) {
                if (!strcmp(name, "_video_ram") || !strcmp(name, "_sprite_ram") || !strcmp(name, "_mailbox")) {
                    p = name;
                    while(*p) {
                        *p = toupper(*p);
                        p++;
                    }
                    printf("#define GPU%-24.24s 0x%04X\n", name, addr >> 2);
                }
            }
        }
        printf("\n");
        fseek(fp, 0L, SEEK_SET);
        while(fgets(string, sizeof(string) - 1, fp) != NULL) {
            if (sscanf(string, " 0x%x %s", &addr, name) == 2) {
                if (strstr(name, "_tiles_ram") != NULL) {
                    p = name;
                    while(*p) {
                        *p = toupper(*p);
                        p++;
                    }
                    printf("#define GPU%-24.24s 0x%04X\n", name, addr);
                }
            }
        }
        printf("\n");
        fseek(fp, 0L, SEEK_SET);
        while(fgets(string, sizeof(string) - 1, fp) != NULL) {
            if (sscanf(string, " 0x%x %s", &addr, name) == 2) {
                if (strstr(name, "_intromd") != NULL && (strstr(name, "_tiles_ram") != NULL || strstr(name, "_tilemap") != NULL)) {
                    p = name;
                    while(*p) {
                        *p = toupper(*p);
                        p++;
                    }
                    printf("#define GPU%-24.24s 0x%04X\n", name, addr);
                }
            }
        }
        printf("\n");
        fseek(fp, 0L, SEEK_SET);
        while(fgets(string, sizeof(string) - 1, fp) != NULL) {
            if (sscanf(string, " 0x%x %s", &addr, name) == 2) {
                if (strstr(name, "parch") != NULL && (strstr(name, "_tiles_ram") != NULL || strstr(name, "_tilemap") != NULL)) {
                    p = name;
                    while(*p) {
                        *p = toupper(*p);
                        p++;
                    }
                    printf("#define GPU%-24.24s 0x%04X\n", name, addr);
                }
            }
        }
        printf("\n");
        fseek(fp, 0L, SEEK_SET);
        while(fgets(string, sizeof(string) - 1, fp) != NULL) {
            if (sscanf(string, " 0x%x %s", &addr, name) == 2) {
                if (strstr(name, "_history") != NULL && (strstr(name, "_tiles_ram") != NULL || strstr(name, "_tilemap") != NULL)) {
                    p = name;
                    while(*p) {
                        *p = toupper(*p);
                        p++;
                    }
                    printf("#define GPU%-24.24s 0x%04X\n", name, addr);
                }
                if (strstr(name, "_gameover") != NULL && (strstr(name, "_tiles_ram") != NULL || strstr(name, "_tilemap") != NULL)) {
                    p = name;
                    while(*p) {
                        *p = toupper(*p);
                        p++;
                    }
                    printf("#define GPU%-24.24s 0x%04X\n", name, addr);
                }
                if (strstr(name, "_ending") != NULL && (strstr(name, "_tiles_ram") != NULL || strstr(name, "_tilemap") != NULL)) {
                    p = name;
                    while(*p) {
                        *p = toupper(*p);
                        p++;
                    }
                    printf("#define GPU%-24.24s 0x%04X\n", name, addr);
                }
            }
        }
        fclose(fp);
    }

    printf("\n#endif /* GPU_H */\n");

    printf("\n");

    return 0;
}
