/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

void room_10_touchobj()
{
    int x = 0;
    int y = 0;
    int h = 0;
    int v = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    TOUCH_CROSSES
    TOUCH_HEARTS
    TOUCH_LEVER
}

void dragon() {
    int n = 0;

    /* Head position */
    if (enemies[0].speed < 150) /* Using speed as temp */
        enemies[0].speed ++;
    else
        enemies[0].speed = 0;

    if (enemies[0].speed < 110)
        enemies[0].animation = 0;
    else
        enemies[0].animation = 1;

    /* Draw head */
    sprite_ram[sprite_idx++] = ((8 + (enemies[0].animation * 3)) << 9) | (120);
    sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_10_SPRITE_416_56_OFS;
    /*srctile.w = 32;
    srctile.h = 24;
    srctile.x = 416;
    srctile.y = 56 + (changetiles * 120);;
    destile.w = 32;
    destile.h = 24;
    destile.x = 120;
    destile.y = 8 + (enemies->animation[0] * 3);
    SDL_RenderCopy(renderer,tiles,&srctile,&destile);*/
    /* Draw snout */
    sprite_ram[sprite_idx++] = ((8 + (enemies[0].animation * 3) + 24) << 9) | (120);
    sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_10_SPRITE_448_56_OFS;
    /*srctile.h = 16;
    srctile.x = 448;
    destile.h = 16;
    destile.y += 24;
    SDL_RenderCopy(renderer,tiles,&srctile,&destile);*/

    /* Spit fire */
    if (enemies[0].animation == 1) {
        if ((enemies[0].speed == 115) || (enemies[0].speed == 125) || (enemies[0].speed == 135) || (enemies[0].speed == 145))
            enemies[0].direction = 1;
        if ((enemies[0].speed == 110) || (enemies[0].speed == 120) || (enemies[0].speed == 130) || (enemies[0].speed == 140))
            enemies[0].direction = 0;

        sprite_ram[sprite_idx++] = (51 << 9) | (119 + (enemies[0].direction * 16));
        sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_10_SPRITE_504_56_OFS + (enemies[0].direction * 576);
        sprite_ram[sprite_idx++] = (75 << 9) | (127);
        sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_10_SPRITE_480_56_OFS + (enemies[0].direction * 576);

        /*srctile.x = 504 + (enemies->direction[0] * 48);
        srctile.y = 56 + (changetiles * 120);
        srctile.w = 24;
        srctile.h = 24;
        destile.x = 119 + (enemies->direction[0] * 16);
        destile.y = 51;
        destile.w = 24;
        destile.h = 24;
        SDL_RenderCopy(renderer,tiles,&srctile,&destile);
        srctile.x = 480 + (enemies->direction[0] * 48);
        destile.y = 75;
        destile.x = 127;
        SDL_RenderCopy(renderer,tiles,&srctile,&destile);*/
    }

    /* Make fire in ground */
    if (enemies[0].speed == 150) {
        //Mix_PlayChannel(-1, fx[0], 0);;
        for (n = 0; n < 16; n += 8) {
            if (proyec[n] == 0) {
                proyec[n] = 120 << 8;
                proyec[n + 1] = 464;
                proyec[n + 2] = 128 << 8;
                proyec[n + 3] = 472;
                proyec[n + 4] = 136 << 8;
                proyec[n + 5] = 472;
                proyec[n + 6] = 144 << 8;
                proyec[n + 7] = 464;
                n = 16;
            }
        }
    }

    /* Fire movement & animation */
    for (n = 0; n < 16; n += 2) {
        if (proyec[n] > 0) {
            if ((n < 3) || ((n > 7) && (n < 11))) {
                if (proyec[n] > (48 << 8)) {
                    proyec[n] -= INC_0_3;
                    /* Animation */
                    if (counter[0] % 8 == 0) {
                        if (proyec[n + 1] == 464)
                            proyec[n + 1] = 472;
                        else
                            proyec[n + 1] = 464;
                    }
                } else {
                    proyec[n] = 0;
                    proyec[n + 1] = 0;
                }
            }
            else {
                if (proyec[n] < (248 << 8)) {
                    proyec[n] += INC_0_3;
                    /* Animation */
                    if (counter[0] % 8 == 0) {
                        if (proyec[n + 1] == 464)
                            proyec[n + 1] = 472;
                        else
                            proyec[n + 1] = 464;
                    }
                } else {
                    proyec[n] = 0;
                    proyec[n + 1] = 0;
                }
            }

            if (proyec[n] > 0) {
                sprite_ram[sprite_idx++] = (88 << 9) | ((proyec[n] & 0x1FF00) >> 8);
                if (proyec[n + 1] == 464) {
                    sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_10_SPRITE_464_0_OFS;
                }
                else {
                    sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_10_SPRITE_472_0_OFS;
                }
            }
        }
    }
}

void room_10_events()
{
    /* Dragon fire kills Jean */
    if (((jean.x > (127 << 8)) && (jean.x < (144 << 8))) && (jean.y < (89 << 8))) {
        if ((enemies[0].speed > 109) && (enemies[0].speed < 146))
            jean.death = 1;
    }
}
