/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

void room_11_touchobj()
{
    int x = 0;
    int y = 0;
    int h = 0;
    int v = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    /* Touch spikes, water or fire */
    if (((video_ram[y+3][x] == TILE005_ID) || (video_ram[y+3][x+1] == TILE005_ID)) || (((video_ram[y+3][x] >= TILE501_ID) && (video_ram[y+3][x] <= TILE504_ID))|| ((video_ram[y+3][x+1] >= TILE501_ID) && (video_ram[y+3][x+1] <= TILE504_ID))) || (((video_ram[y+3][x] == TILE059_ID) || (video_ram[y+3][x] == TILE059_ID)) || ((video_ram[y+3][x+1] == TILE060_ID) && (video_ram[y+3][x+1] == TILE060_ID)))) {
        if ((room[0] == 11) && (y+3 == 20) && (x < 4))
            jean.death = 0;
        else {
            if (jean.death == 0)
                jean.death = 1;
        }
    }

    TOUCH_CROSSES
    TOUCH_HEARTS
    TOUCH_CHECKPOINT
}

void fireball()
{
    int x = 0;
    int y = 0;
    uint32_t sprite1 = (GPU_TILES_RAM + ROOM_11_SPRITE_576_40_OFS);

    /* Current tile X and Y */
    x = enemies[0].x / 0x800;
    y = enemies[0].y / 0x800;

    /* Follow Jean */
    if (enemies[0].x < jean.x + INC_1_0) {
        enemies[0].direction = 1;
        if (((video_ram[y][x + 2] & WALL_FLAG) == 0) && ((video_ram[y + 1][x + 2] & WALL_FLAG) == 0)) {
            if (enemies[0].fire == 0)
                enemies[0].x += INC_0_3;
        }
    }
    if (enemies[0].x > jean.x - INC_1_0) {
        enemies[0].direction = 0;
        if (((video_ram[y][x - 1] & WALL_FLAG) == 0) && ((video_ram[y + 1][x - 1] & WALL_FLAG) == 0)) {
            if (enemies[0].fire == 0)
                enemies[0].x -= INC_0_3;
        }
    }
    if (enemies[0].y < jean.y + INC_1_0) {
        if (((video_ram[y + 2][x] & WALL_FLAG) == 0) && ((video_ram[y + 2][x + 1] & WALL_FLAG) == 0)) {
            if (enemies[0].fire == 0)
                enemies[0].y += INC_0_3;
            enemies[0].fire = 0;
        } else {
            enemies[0].fire = 1; /* Using fire like flag */
            if (enemies[0].x > jean.x - INC_1_0)
                enemies[0].x -= INC_0_3;
            else
                enemies[0].x += INC_0_3;
        }
    }
    if (enemies[0].y > jean.y + INC_1_0) {
        if (((video_ram[y - 1][x] & WALL_FLAG) == 0) && ((video_ram[y - 1][x + 1] & WALL_FLAG) == 0)) {
            enemies[0].y -= INC_0_3;
            enemies[0].fire = 0;
        } else {
            enemies[0].fire = 1; /* Usando fire como flag */
            if (enemies[0].x > jean.x - 1)
                enemies[0].x -= INC_0_3;
            else
                enemies[0].x += INC_0_3;
        }
    }

    /* Animation */
    enemies[0].animation = counter[0] / 15;

    /* Draw */
    sprite_ram[sprite_idx] = ((enemies[0].y & 0x1FF00) << 1) | ((enemies[0].x & 0x1FF00) >> 8);
    if (enemies[0].direction == 1)
        sprite_ram[sprite_idx] |= MIRROR_FLAG;
    sprite_idx++;
    sprite_ram[sprite_idx++] = sprite1 + enemies[0].animation * 128;
}
