/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

void room_19_touchobj()
{
    int x = 0;
    int y = 0;
    int h = 0;
    int v = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    /* Touch spikes, water or fire */
    if (((video_ram[y+3][x] == TILE005_ID) || (video_ram[y+3][x+1] == TILE005_ID)) || (((video_ram[y+3][x] >= TILE501_ID) && (video_ram[y+3][x] <= TILE504_ID))|| ((video_ram[y+3][x+1] >= TILE501_ID) && (video_ram[y+3][x+1] <= TILE504_ID))) || (((video_ram[y+3][x] == TILE059_ID) || (video_ram[y+3][x] == TILE059_ID)) || ((video_ram[y+3][x+1] == TILE060_ID) && (video_ram[y+3][x+1] == TILE060_ID)))) {
        if ((room[0] == 11) && (y+3 == 20) && (x < 4))
            jean.death = 0;
        else {
            if (jean.death == 0)
                jean.death = 1;
        }
    }

    TOUCH_CROSSES
    TOUCH_HEARTS
    TOUCH_CHECKPOINT
}

void room_19_events()
{
    /* Open door */
    if ((jean.y > INC_16_0) && (jean.flags[3] == 1) && (video_ram[16][0] == TILE347_ID)) {
        video_ram[16][0] = 0;
        video_ram[17][0] = 0;
        video_ram[18][0] = 0;
        video_ram[19][0] = 0;
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
        spi_write((room[0] - 1) * (MAP_SIZE), (uint8_t *)&video_ram[0][0], MAP_SIZE);
        //Mix_PlayChannel(-1, fx[1], 0);
        waitcnt(CNT + _CLKFREQ);
    }
}
