/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#include <propeller.h>

#include "game.h"
#include "overlay.h"

static void satan();
static void crusaders();

void room_24_touchobj()
{
    int x = 0;
    int y = 0;
    int v = 0;

    x = (jean.x + INC_2_0) / 0x800;
    y = jean.y / 0x800;

    /* Touch red parchment */
    if (((video_ram[y+1][x] >= TILE339_ID) && (video_ram[y+1][x] <= TILE342_ID)) || ((video_ram[y+1][x+1] >= TILE339_ID) && (video_ram[y+1][x+1] <= TILE342_ID))) {
        jean.flags[6] = 3;
        /* Delete parchment */
        video_ram[14][28] = 0;
        video_ram[14][29] = 0;
        video_ram[15][28] = 0;
        video_ram[15][29] = 0;
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
    }

    /* Touch cup */
    if ((video_ram[y][x + 1] == TILE650_ID) || (video_ram[y + 1][x + 1] == TILE650_ID) || (video_ram[y + 2][x + 1] == TILE650_ID)) {
        //Mix_HaltMusic();
        //Mix_PlayChannel(-1, fx[5], 0);
        waitcnt(CNT + _CLKFREQ * 2);
        spi_read((room[0] - 1) * (MAP_SIZE), (uint8_t *)&video_ram[0][0], MAP_SIZE);
        memset(&sprite_ram[2], 0, sizeof(sprite_ram) - 8);
        hs_tx(sizeof(sprite_ram) / 4, (int32_t)sprite_ram, 0, GPU_SPRITE_RAM);
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
        /* Delete Satan */
        enemies[0].type = 88;
        enemies[0].speed = 0; /* Using speed as counter */
        enemies[0].adjustx1 = 0;
        enemies[0].adjustx2 = 0;
        enemies[0].adjusty1 = 0;
        enemies[0].adjusty2 = 0;
        /* Deleting shoots */
        memset(proyec, 0, sizeof(proyec));
        /* Init crusaders */
        for (v=1;v<7;v++)
            enemies[v].type = 17;
        enemies[0].adjustx2 = 15 << 8;
        enemies[0].adjusty2 = 23 << 8;
    }
}

void room_24_drawenemies()
{
    if (jean.flags[6] == 5)
        crusaders();
    else if (enemies[0].type == 18) {
        satan();
    }
    else if (enemies[0].type == 88) {
        /* Draw smoke */
        if ((enemies[0].speed < 10) || ((enemies[0].speed > 19) && (enemies[0].speed < 30)) || ((enemies[0].speed > 39) && (enemies[0].speed < 50))) {
            sprite_ram[sprite_idx++] = ((enemies[0].y & 0x1FF00) << 1) | ((enemies[0].x & 0x1FF00) >> 8);
            sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_24_SPRITE_696_0_OFS;
            sprite_ram[sprite_idx++] = (((enemies[0].y + (24 << 8)) & 0x1FF00) << 1) | ((enemies[0].x & 0x1FF00) >> 8);
            sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_24_SPRITE_696_24_OFS;
        }
        else {
            sprite_ram[sprite_idx++] = ((enemies[0].y & 0x1FF00) << 1) | ((enemies[0].x & 0x1FF00) >> 8);
            sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_24_SPRITE_728_0_OFS;
            sprite_ram[sprite_idx++] = (((enemies[0].y + (24 << 8)) & 0x1FF00) << 1) | ((enemies[0].x & 0x1FF00) >> 8);
            sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_24_SPRITE_728_24_OFS;
        }
        /*srctile.y = 0 + (changetiles * 120);
        srctile.w = 32;
        srctile.h = 48;
        destile.w = 32;
        destile.h = 48;
        destile.x = enemies->x[i];
        destile.y = enemies->y[i];
        SDL_RenderCopy(renderer, tiles, &srctile, &destile);
        if (enemies->speed[i] == 5)
            Mix_PlayChannel(-1, fx[6], 0);*/
    }
}

static void crusaders()
{
    int i;

    for (i = 0; i < 4; i++) {
        /* Init values */
        if (enemies[i].type != 16) {
            enemies[i].type = 16;
            enemies[i].x = (-52 - (24 * i)) << 8;
            enemies[i].y = 136 << 8;
        }

        /* Mover & animation */
        /* Jump when needed */
        if ((enemies[i].x == (144 << 8)) || (enemies[i].x == (152 << 8)) || (enemies[i].x == (160 << 8)) || (enemies[i].x == (168 << 8)))
            enemies[i].fire = 1;

        /* Jump */
        if (enemies[i].fire == 1) { /* Short jump */
            if (enemies[i].speed < 23) {
                enemies[i].speed += 2;
                enemies[i].y -= INC_1_0;
                enemies[i].animation = 0;
            }
            else {
                enemies[i].y += INC_1_0;
                enemies[i].speed += 2;
                enemies[i].animation = 0;
            }
            if (enemies[i].speed == 32) { /* Touching ground, reboot flags */
                enemies[i].speed = 0;
                enemies[i].fire = 0;
            }
        }
        else if (enemies[i].fire == 2) { /* Long jump */
            if (enemies[i].speed < 8) {
                enemies[i].speed += 1;
                enemies[i].y -= INC_1_0;
                enemies[i].animation = 0;
            }
            else {
                enemies[i].y += INC_1_0;
                enemies[i].speed += 1;
                enemies[i].animation = 0;
            }
            if (enemies[i].speed == 16) {
                enemies[i].fire = 0;
                enemies[i].speed = 0;
            }
        }

        if (enemies[i].animation < 13)
            enemies[i].animation++;
        else
            enemies[i].animation = 0;

        /* Fall */
        if (room[0] == 5) {
            if (enemies[i].x > (206 << 8)) {
                if (enemies[i].speed < 8) {
                    enemies[i].speed++;
                    enemies[i].y += INC_2_0;
                    enemies[i].animation = 0;
                }
            }
        }

        /* Movement */
        if ((room[0] == 6) && (enemies[i].speed > 0))
            enemies[i].x += INC_0_75;
        else
            enemies[i].x += INC_0_5;

        if ((enemies[i].x > -INC_8_0) && (enemies[i].x < (256 << 8))) {
            sprite_ram[sprite_idx++] = ((enemies[i].y & 0x1FF00) << 1) | ((enemies[i].x & 0x1FF00) >> 8) | MIRROR_FLAG;
            sprite_ram[sprite_idx++] = GPU_TILES_RAM + SPRITE_64_64_OFS + (192 * (enemies[i].animation / 7));
        }
    }
}

static void satan()
{
    int n = 0;
    int r = 0;
    int x = 0;

    /* Movement */
    if (enemies[0].direction == 0) { /* Subiendo */
        if (enemies[0].y > enemies[0].limleft)
            enemies[0].y -= INC_0_5;
        else
            enemies[0].direction = 1;
    }
    if (enemies[0].direction == 1) { /* Bajando */
        if (enemies[0].y < enemies[0].limright)
            enemies[0].y += INC_0_5;
        else
            enemies[0].direction = 0;
    }

    /* Animation */
    if ((counter[0] == 1) || (counter[0] == 11) || (counter[0] == 21)) {
        if (enemies[0].animation == 0)
            enemies[0].animation = 1;
        else
            enemies[0].animation = 0;
    }

    /* Draw */
    sprite_ram[sprite_idx++] = ((enemies[0].y & 0x1FF00) << 1) | 192;
    sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_24_SPRITE_192_88_OFS + (enemies[0].animation * 768);
    sprite_ram[sprite_idx++] = (((enemies[0].y + (24 << 8)) & 0x1FF00) << 1) | 192;
    sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_24_SPRITE_224_88_OFS + (enemies[0].animation * 768);

    /* Init shoots */
    if (((enemies[0].y == (37 << 8)) && (enemies[0].direction == 0)) || ((enemies[0].y == (20 << 8)) && (enemies[0].direction == 1)) || ((enemies[0].y == (62 << 8)) && (enemies[0].direction == 0))) {
        x = enemies[0].y;
        switch (x) {
            case 20 << 8:
                r = 0;
                break;
            case 37 << 8:
                r = 6;
                break;
            case 62 << 8:
                r = 12;
                break;
        }
        if ((proyec[r] == 0) && (proyec[r + 2] == 0) && (proyec[r + 4] == 0)) {
            proyec[r] = (190 << 8);
            proyec[r + 1] = enemies[0].y + (15 << 8);
            proyec[r + 2] = (190 << 8);
            proyec[r + 3] = enemies[0].y + (10 << 8);
            proyec[r + 4] = (190 << 8);
            proyec[r + 5] = enemies[0].y + (20 << 8);
            //Mix_PlayChannel(-1, fx[0], 0);
        }
    }

    /* Move shoots */
    for (n = 0; n < 17; n += 2) {
        if ((proyec[n] > (16 << 8)) && ((proyec[n + 1] > (8 << 8)) && (proyec[n + 1] < (160 << 8)))) {
            proyec[n] -= INC_2_0;
            if ((n + 1 == 3) || (n + 1 == 9) || (n + 1 == 15))
                proyec[n + 1] -= INC_0_75;
            if ((n + 1 == 5) || (n + 1 == 11) || (n + 1 == 17))
                proyec[n + 1] += INC_0_75;

            sprite_ram[sprite_idx++] = ((proyec[n + 1] & 0x1FF00) << 1) | ((proyec[n] & 0x1FF00) >> 8);
            sprite_ram[sprite_idx++] = GPU_TILES_RAM + ROOM_24_SPRITE_680_32_OFS;
        }
        else {
            proyec[n] = 0;
            proyec[n + 1] = 0;
        }
    }
}

void room_24_events() {
    int x = 0;
    int y = 0;

    if ((jean.state[1] == 12) && (jean.x > INC_8_0) && (jean.flags[6] == 0)) {
        /* Block entry */
        video_ram[16][0] = TILE099_ID;
        video_ram[17][0] = TILE099_ID;
        video_ram[18][0] = TILE099_ID;
        video_ram[19][0] = TILE099_ID;
        jean.flags[6] = 1;
        /* Mark checkpoint */
        jean.checkpoint[0] = 24;
        jean.checkpoint[1] = jean.x;
        jean.checkpoint[2] = jean.y;
    }
    else if ((jean.flags[6] == 1) && (jean.state[1] > 0) && (counter[0] == 0)) {
        /* Putting crosses */
        switch (jean.state[1]) {
            case 1:
                x = 11;
                y = 5;
                break;
            case 2:
                x = 10;
                y = 5;
                break;
            case 3:
                x = 8;
                y = 8;
                break;
            case 4:
                x = 5;
                y = 8;
                break;
            case 5:
                x = 4;
                y = 8;
                break;
            case 6:
                x = 2;
                y = 12;
                break;
            case 7:
                x = 5;
                y = 14;
                break;
            case 8:
                x = 6;
                y = 14;
                break;
            case 9:
                x = 9;
                y = 14;
                break;
            case 10:
                x = 10;
                y = 14;
                break;
            case 11:
                x = 13;
                y = 13;
                break;
            case 12:
                x = 15;
                y = 16;
                break;
        }
        video_ram[y][x] = TILE084_ID;
        jean.state[1]--;
        statusbar();
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
        //Mix_PlayChannel(-1, fx[1], 0);
    }
    else if ((jean.flags[6] == 1) && (jean.state[1] == 0) && (counter[0] == 29)) {
        /* Draw cup */
        video_ram[3][15] = TILE650_ID;
        video_ram[3][16] = TILE650_ID + 1;
        video_ram[4][15] = TILE650_ID + 2;
        video_ram[4][16] = TILE650_ID + 3;
        jean.flags[6] = 2;
        hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
        //Mix_PlayChannel(-1, fx[1], 0);
    }
    /* Killed Satan, Smoke appears */
    else if (enemies[0].type == 88) {
        if (enemies[0].speed < 90)
            enemies[0].speed++;
        else {
            enemies[0].speed = 0;
            enemies[0].type = 17;
            enemies[0].x = 0;
            enemies[0].y = 0;
            /* Putting red parchment */
            video_ram[14][28] = TILE339_ID;
            video_ram[14][29] = TILE340_ID;
            video_ram[15][28] = TILE341_ID;
            video_ram[15][29] = TILE342_ID;
            memset(&sprite_ram[2], 0, sizeof(sprite_ram) - 8);
            hs_tx(sizeof(sprite_ram) / 4, (int32_t)sprite_ram, 0, GPU_SPRITE_RAM);
            hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
        }
    }
}

static void showparchment() {
    memset(sprite_ram, 0, sizeof(sprite_ram));

    hs_tx(sizeof(sprite_ram) / 4, (int32_t)sprite_ram, 0, GPU_SPRITE_RAM);
    hs_tx(sizeof(mailbox) / 4, (int32_t)mailbox, 3, GPU_MAILBOX);
    waitcnt(CNT + _CLKFREQ * 5);

    hs_tx(sizeof(sprite_ram) / 4, (int32_t)sprite_ram, 5, GPU_SPRITE_RAM);
    hs_tx(sizeof(video_ram) / 4, (int32_t)video_ram, 0, GPU_VIDEO_RAM);
}

void redparchment() {
    mailbox[0] = GPU_REDPARCH_TILES_RAM;
    mailbox[1] = REDPARCH_TILESET_SIZE;
    mailbox[2] = GPU_REDPARCH_TILEMAP;
    showparchment();
    jean.flags[6] = 4;
}

void blueparchment() {
    mailbox[0] = GPU_BLUEPARCH_TILES_RAM;
    mailbox[1] = BLUEPARCH_TILESET_SIZE;
    mailbox[2] = GPU_BLUEPARCH_TILEMAP;
    showparchment();
}
