/**
 * Abbaye des Morts for Parallax Propeller
 * Copyright (c) 2015 Marco Maccaferri
 *
 * TERMS OF USE: MIT License
 */

#ifndef SPI_DRIVER_H_
#define SPI_DRIVER_H_

#include <stdint.h>

#define SPI_SI      (1 << 0)
#define SPI_SO      (1 << 1)
#define SPI_CLK     (1 << 4)
#define SPI_CS      (1 << 5)

#define SPI_SIO0    (1 << 0)
#define SPI_SIO1    (1 << 1)
#define SPI_SIO2    (1 << 2)
#define SPI_SIO3    (1 << 3)

#define SPI_HOLD    (1 << 3)

void spi_init();

void spi_write(int32_t addr, const uint8_t * bytes, int32_t length);
void spi_read(int32_t addr, uint8_t * bytes, int32_t length);

void spi_write_byte(int32_t b);
void spi_write_addr(int32_t addr);

int32_t spi_read_byte();

#endif /* SPI_DRIVER_H_ */
